function output = import_soundings_NYA(datapath,radiosondestartdate)

% create the output as a struct
output = struct;

%Find, open and read the file
file_dir = dir([datapath 'NYA_radiosonde_' radiosondestartdate(1:4) '-' radiosondestartdate(5:6) '.tab']);
NYA_txt = fullfile(datapath,file_dir.name);
fileID = fopen(NYA_txt);
NYA_txt = textscan(fileID,'%s','delimiter','\t') ;
radiosondestart=datenum(radiosondestartdate,'yyyymmddHH')-1/(24*4);
radiosondeend=datenum(radiosondestartdate,'yyyymmddHH')+1.5/24;

idt=find(strncmp(NYA_txt{1,1},[radiosondestartdate(1:4) '-' radiosondestartdate(5:6) '-' radiosondestartdate(7:8) 'T'],11));

id=find(datenum(cellstr(NYA_txt{1,1}(idt)),'yyyy-mm-ddTHH:MM:SS') > radiosondestart & radiosondeend > datenum(cellstr(NYA_txt{1,1}(idt)),'yyyy-mm-ddTHH:MM:SS'));
%start_p1=str2double(radiosondestartdate(9:10))+1;
%idt=find(strncmp(NYA_txt{1,1},[radiosondestartdate(1:4) '-' radiosondestartdate(5:6) '-' radiosondestartdate(7:8) 'T' radiosondestartdate(9:10)],13) | strncmp(NYA_txt{1,1},[radiosondestartdate(1:4) '-' radiosondestartdate(5:6) '-' radiosondestartdate(7:8) 'T' num2str(start_p1)],13));

idr=idt(id);
%read all the parameters line per line
for n=1:length(idr)   
    m=idr(n);
    time{n}=string(NYA_txt{1,1}(m,1));   
    lat(n)=str2double(NYA_txt{1,1}{m+1,1});
    lon(n)=str2double(NYA_txt{1,1}{m+2,1});
    GeopHgt (n)=str2double(NYA_txt{1,1}{m+3,1});
    GPSHgt(n)=str2double(NYA_txt{1,1}{m+4,1});
    ElapTime(n)=str2double(NYA_txt{1,1}{m+5,1});
    Pressure(n)=str2double(NYA_txt{1,1}{m+6,1});
    Temp(n)=str2double(NYA_txt{1,1}{m+7,1});
    RH(n)=str2double(NYA_txt{1,1}{m+8,1});
    winddir(n)=str2double(NYA_txt{1,1}{m+9,1});
    windspeed(n)=str2double(NYA_txt{1,1}{m+10,1});
    datevec(n)=datenum(cellstr(time(n)),'yyyy-mm-ddTHH:MM:SS');

end

%write the output parameters
output.ElapTime=ElapTime;
output.datevec=datevec;
output.time=time;
output.Pressure=Pressure;
output.GeopHgt=GeopHgt;
output.Temp=Temp+273.15;
output.RH=RH;
output.winddir=winddir;
output.windspeed=windspeed;
output.GPSHgt=GPSHgt;
output.lat=lat;
output.lon=lon;
end