
function output = importlog_NYA(dataPath)
%Path do additional Data files
if ~exist(dataPath)
    dataPath = pwd;
end

output = struct;

%delete all times without valid GPS data?
deleteNoGPS = false;
%GPS Time Shift in relation to Computer Time (in days)
timeGPSShift = -2/24;
%use GPS time as time for timeseries
useGPSTime = true;
%Names of additional Data files
filenames=dir(fullfile(dataPath,'Log_*.txt'));

numfids=length(filenames);
Meteodata=cell(1,numfids);

for ii=1:numfids
    
    file    = memmapfile(fullfile(dataPath,filenames(ii).name),'Writable',true);
    comma   = uint8(',');
    point   = uint8('.');
    file.Data(( file.Data==comma)' ) = point;
    
    fid = fopen(fullfile(dataPath,filenames(ii).name));
    C = textscan(fid,'%f %s %s %s %s %s %s %s %f %s %s %s %s %s %s %s %s %s %f %f %f %f %f %f %s %f %s %f %s %f %f %f %f %f %f %f %f %f %f %f %s %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %s %s %s %s %s %s %s %s %s %f %f %f %f %f %f %f %f %f %f %f %f %s %f %f %f %f %f %f %s %f %f %f %f %f %f %s %f %f %f %f %f %f %f %s %f %f %f %f %f %f %f %f %f %f %f %f %f %s %f %f %f %f %f %f %f %f %f %f %s %s %f %f %f %f %f %f %f %f %s %s %s %s %f %f %f %f %f %f %f %s %f %f %f %f %f %f %f %f %s %s','HeaderLines',4,'Delimiter',';');
    fclose(fid);
    C_length = cellfun(@numel, C);
    C = cellfun(@(x) x(1:min(C_length)),C,'UniformOutput',false);
    
    
    
    data_hour = cellfun(@str2double,C{6});
    unique_hour = unique(data_hour);
    for b = 1:length(unique_hour)
        if unique_hour(b) == round(unique_hour(b))
            continue;
        else
            idx = find(data_hour==unique_hour(b));
            for c = length(C):-1:1
                C{1,c}(idx) = [];
            end
        end
    end
    
    
    
    %time from the computer (same time is applied to holograms)
    datestring = strcat(C{2},'-',C{4},'-',C{5},'-',C{6},'-',C{7},'-',C{8});
    timeComputer = datenum(datestring,'yyyy -mm -dd -HH -MM -SS');
    timeComputerDateTime = datetime(datestring,'InputFormat','y -M -d -H -m -s');
    
    %time from the GPS signal
    datestring_IMU = strcat(C{62},'-',C{63},'-',C{64},'-',C{65},'-',C{66},'-',C{67});
    timeGPS = datenum(datestring_IMU,'yyyy -mm -dd -HH -MM -SS');
    timeGPSDateTime = datetime(datestring_IMU,'InputFormat','y -M -d -H -m -s');
    
    if deleteNoGPS
        noGPS = timeGPS < 1e4;
        if sum(noGPS)
            warning('Because of a lack of GPS signal %s time points are delete.', num2str(sum(noGPS)))
            C = cellfun(@(x) x(~noGPS),C,'UniformOutput',false);
            timeComputer = timeComputer(~noGPS);
            timeGPS = timeGPS(~noGPS);
        end
    end
    timeGPS = timeGPS + timeGPSShift;
    %Time shift between GPS and computer time (after correction
    %timeGPSShift)
    timeShift = timeGPS-timeComputer;
    
    additionalData{ii}.timeShift = timeShift;
    additionalData{ii}.timeComputer = timeComputer;
    additionalData{ii}.timeGPS = timeGPS;
    
    if useGPSTime
        time = timeGPS;
    else
        time = timeComputer;
    end
    
    %                 Meteodata{ii}.time = datenum(datestring,'yyyy');
    %                 Meteodata{ii}.time = datenum(datestring,'yyyy -mm -dd -HH -MM -SS');
    %                 Meteodata{ii}.outPress      = C{22};
    %                 Meteodata{ii}.outTemp       = C{30};
    %                 Meteodata{ii}.outRH         = C{31};
    %                 Meteodata{ii}.outDew        = C{32};
    additionalData{ii}.WS_x          = C{33};
    additionalData{ii}.WS_y          = C{34};
    additionalData{ii}.WS_z          = C{35};
    additionalData{ii}.azimuthWS     = C{43};
    additionalData{ii}.azimuthWD     = C{44};
    additionalData{ii}.WD_Elevation  = C{45};
    additionalData{ii}.sonicTemp     = C{36};
    additionalData{ii}.sonicStatus   = C{38};
    %
    %
    %                 IMU{ii}.time    = datenum(datestring_IMU,'yyyy -mm -dd -HH -MM -SS');
    %                 IMU{ii}.Accel_X    = C{70};
    %                 IMU{ii}.Accel_Y    = C{71};
    %                 IMU{ii}.Accel_Z    = C{72};
    %                 IMU{ii}.Gyro_X     = C{73};
    %                 IMU{ii}.Gyro_Y     = C{74};
    %                 IMU{ii}.Gyro_Z     = C{75};
    additionalData{ii}.Roll       = C{90};
    additionalData{ii}.Pitch      = C{91};
    additionalData{ii}.Yaw        = C{92};
    %                 IMU{ii}.Nav_Vel_N  = C{105};
    %                 IMU{ii}.Nav_Vel_E  = C{106};
    %                 IMU{ii}.Nav_Vel_D  = C{107};
    additionalData{ii}.Nav_Lat    = C{111};
    additionalData{ii}.Nav_Long   = C{112};
    additionalData{ii}.Nav_Alt    = C{113};
    %                 IMU{ii}.Ship_Accel_X   = C{123};
    %                 IMU{ii}.Ship_Accel_Y   = C{124};
    %                 IMU{ii}.Ship_Accel_Z   = C{125};
    %                 IMU{ii}.Ship_Vel_X   = C{126};
    %                 IMU{ii}.Ship_Vel_Y   = C{127};
    %                 IMU{ii}.Ship_Vel_Z   = C{128};
    %                 IMU{ii}.GPS_Vel_N   = C{133};
    %                 IMU{ii}.GPS_Vel_E   = C{134};
    %                 IMU{ii}.GPS_Vel_D   = C{135};
    %                 IMU{ii}.GPS_Vel_N_acc   = C{136};
    %                 IMU{ii}.GPS_Vel_E_acc   = C{137};
    %                 IMU{ii}.GPS_Vel_D_acc   = C{138};
    %                 IMU{ii}.GPS_Numsv    = C{140};
    %                 IMU{ii}.GPS_Lat      = C{143};
    %                 IMU{ii}.GPS_Long     = C{144};
    %                 IMU{ii}.GPS_Alt      = C{145};
    %                 IMU{ii}.Pressure     = C{151};
    %                 IMU{ii}.Altitude_P   = C{152};
    
    additionalData{ii}.windowTemp   = C{19};
    additionalData{ii}.laserTemp    = C{20};
    additionalData{ii}.boxTemp      = C{21};
    additionalData{ii}.Pressure     = C{22};
    additionalData{ii}.laserEmissionVolt  = C{26};
    laserOn = cellfun(@(x) strcmpi('TRUE ',x), C{25});
    additionalData{ii}.laserOn  = laserOn;
    additionalData{ii}.laserHeadTemp  = C{28};
    frameRate = cellfun(@str2num, C{29});
    additionalData{ii}.frameRate    = frameRate;
    additionalData{ii}.height       = C{23};
    additionalData{ii}.height_above_ground = C{24};
    
    additionalData{ii}.swUp = C{153};
    additionalData{ii}.swDown = C{154};
    additionalData{ii}.lwUp = C{155};
    additionalData{ii}.lwDown = C{156};
    additionalData{ii}.lwUpTemp = C{157};
    additionalData{ii}.lwDowmTemp = C{158};
    
    
    
end

%Initialize vectors, so that each data can be for the entire campaign in one field
%of the structure (with NaNs inbetween files)
%             names=fieldnames(Meteodata{1,1});
%             for jj=1:length(names)
%                 instData.meteo.(names{jj})=Meteodata{1,1}.(names{jj});
%             end
%             for hh=2:size(Meteodata,2)
%                 for jj = 1:length(names)
%                     instData.meteo.(names{jj}) = ...
%                         [instData.meteo.(names{jj}); NaN; Meteodata{1,hh}.(names{jj})];
%                 end
%             end
%
%                names=fieldnames(IMU{1,1});
%             for jj=1:length(names)
%                 instData.IMU.(names{jj})=IMU{1,1}.(names{jj});
%             end
%             for hh=2:size(IMU,2)
%                 for jj = 1:length(names)
%                     instData.IMU.(names{jj}) = ...
%                         [instData.IMU.(names{jj}); NaN; IMU{1,hh}.(names{jj})];
%                 end
%             end

names=fieldnames(additionalData{1,1});
for jj=1:length(names)
    instData.additionalData.(names{jj})=additionalData{1,1}.(names{jj});
end
for hh=2:size(additionalData,2)
    for jj = 1:length(names)
        instData.additionalData.(names{jj}) = ...
            [instData.additionalData.(names{jj}); NaN; additionalData{1,hh}.(names{jj})];
    end
end

%             instDataMeteo = instData.meteo;
%             instDataMeteo.outPress(instDataMeteo.outPress==0) = nan;
%             instData.gps.altitudeNew = instDataHOLIMO3G_SON2016.calcAltFromPress(instDataMeteo.outPress);
%
%             instDataMeteo = instDataHOLIMO4B_AARW2018.windCorrection(instData.meteo, instData.IMU,instDataMeteo);
%
%             instDataMeteo = timeserie(instDataMeteo.time, instDataMeteo);
%             save(fullfile(Holimo3GDataPath,'HOLIMO4B_NYALESUND2019_instMeteo.mat'),'instDataMeteo');
%
%             instDataIMU = instData.IMU;
%             instDataIMU   = timeserie(instDataIMU.time, instDataIMU);
%             save(fullfile(Holimo3GDataPath,'HOLIMO4B_NYALESUND2019_instDataIMU.mat'),'instDataIMU');
%

instAdditionalData = instData.additionalData;

%convert imported data to timeserie
instAdditionalDataTS   = timeserie(instAdditionalData.timeGPS, instAdditionalData);

%add the imported data to the tsData
%instead of "InstData", a differnet name can be choosen
%adding multiple timeseries is possible
output.instData = instAdditionalDataTS;


%save(fullfile(Holimo3GDataPath,'HOLIMO4B_NYALESUND2019_instAdditionalData.mat'),'instAdditionalData');

end
