
function rdtemp=interpolate_radiosondes(soundingdata_path,date,elevation)


rdtemp=struct;

if strcmp(date(1:8),'20191110')
 rad_number=2;   
 start_rad=[11 ; 17];
elseif strcmp(date(1:8),'20191111')
 rad_number=3; 
  start_rad=[11 ; 14; 19];
elseif strcmp(date(1:8),'20191112')
  rad_number=3; 
    start_rad=[11 ; 14; 17];
elseif strcmp(date(1:8),'20200401')
  rad_number=1; 
    start_rad=[17];
else
  rad_number=1;
  start_rad=[11];
end

for j=1:rad_number
    output(j)=import_soundings_NYA(soundingdata_path, [date(1:8) num2str(start_rad(j))]);
end




Yq=[20:0.5:elevation];

rh_altint=NaN(length(Yq),rad_number);

temp_altint=NaN(length(Yq),rad_number);
timeint=[];
for i=1:rad_number
    [~,height_id]=min(abs(output(i).GeopHgt(:)-elevation));
    [alt,temp]=consolidator(output(i).GeopHgt(1:height_id),output(i).Temp(1:height_id));  
    temp_altint(:,i)=interp1(flip(alt), flip(temp),Yq, 'spline');
    timeint=[timeint; output(i).datevec(1)];
    
    [~,rh]=consolidator(output(i).GeopHgt(1:height_id),output(i).RH(1:height_id));
    rh_altint(:,i)=interp1(flip(alt), flip(rh),Yq, 'spline');

end

if rad_number>1
    
    Xq=[(output(1).datevec(1)-3/24):1/(24*60):(output(end).datevec(1)+3/24)];
    timeint=[(output(1).datevec(1)-3/24); timeint; (output(end).datevec(1)+3/24)];
    temp_altint=[temp_altint(:,1) temp_altint(:,:) temp_altint(:,end)];
     rh_altint=[rh_altint(:,1) rh_altint(:,:) rh_altint(:,end)];

else
    Xq=[(output(1).datevec(1)-6/24):1/(24*60):(output(1).datevec(1)+6/24)];
    timeint=[(output(1).datevec(1)-6/24); output(i).datevec(1); (output(i).datevec(1)+6/24)];
    temp_altint=[temp_altint temp_altint temp_altint];
    rh_altint=[rh_altint rh_altint rh_altint];

end
temp_inter_heighttime=NaN(length(Yq),length(Xq));
rh_inter_heighttime=NaN(length(Yq),length(Xq));

for k=1:length(temp_altint(:,1))
    temp_inter_heighttime(k,:)=interp1(timeint,temp_altint(k,:),Xq);
    RH_inter_heighttime(k,:)=interp1(timeint,rh_altint(k,:),Xq);
end



rdtemp.RH_inter_heighttime=RH_inter_heighttime;
rdtemp.temp_inter_heighttime=temp_inter_heighttime;
rdtemp.time=Xq;
rdtemp.alt=Yq;
rdtemp.time_radstart=timeint(2:end-1);

end