function [data] = readRemoteSensing_NyAlesund(filepath)
% filepath: path to netCDF-File

finfo = ncinfo(filepath);
data = [];
for i = 1:length(finfo.Variables)
    var = finfo.Variables(i).Name;
    data.(var) = ncread(filepath,var);
end

for j = 1:length(finfo.Attributes)
    if strcmp(finfo.Attributes(j).Name,'year')
        yyyy = double(finfo.Attributes(j).Value);
    elseif strcmp(finfo.Attributes(j).Name,'month')
        mm = double(finfo.Attributes(j).Value);
    elseif strcmp(finfo.Attributes(j).Name,'day')
        dd = double(finfo.Attributes(j).Value);
    end
end

data.time = datenum(0,0,0,double(data.time),0,0) + datenum(yyyy,mm,dd);
end